<template>
  <div class="ui-token-widget">
    <div class="ui-token-widget_token">
      <ui-footer-token-widget-price :price="price"/>
      <div class="uikit-flex justify-center">
        <ui-button
          variant="violet"
          class="uikit-mr-6"
          :size="32"
          v-bind="action"
        >
          Buy SLR
        </ui-button>

        <ui-footer-token-widget-add-menamask-button @click="handleWalletClick"/>
      </div>
    </div>
    <div class="ui-token-widget_info">
      <ui-footer-token-widget-info-row
        label="Total supply"
        :value="totalSupply"
      />
      <ui-footer-token-widget-info-row
        label="Total blocked"
        :value="totalBlocked"
      />
      <ui-footer-token-widget-info-row
        label="Circulating supply"
        :value="circulatingSupply"
      />
      <ui-footer-token-widget-info-row
        label="Total Burned"
        :value="totalBurned"
      />
      <ui-footer-token-widget-info-row
        label="Market Cap"
        :value="marketCap"
      />
    </div>
  </div>
</template>

<script lang="ts">
import type { UiButtonProps } from '../UiButton'
import { defineComponent, PropType } from 'vue'
import { UiButton } from '../UiButton'
import { UiIconWalletMetamask } from '../UiIcon'
import UiFooterTokenWidgetPrice from './UiFooterTokenWidgetPrice.vue'
import UiFooterTokenWidgetInfoRow from './UiFooterTokenWidgetInfoRow.vue'
import UiFooterTokenWidgetAddMenamaskButton from './UiFooterTokenWidgetAddMenamaskButton.vue'

export default defineComponent({
  props: {
    price: {
      type: Number,
    },
    totalSupply: {
      type: Number,
    },
    totalBlocked: {
      type: Number,
    },
    circulatingSupply: {
      type: Number,
    },
    totalBurned: {
      type: Number,
    },
    marketCap: {
      type: Number,
    },
    action: {
      type: Object as PropType<UiButtonProps>
    }
  },
  emits: ['wallet-click'],
  setup(props, { emit }) {
    const handleWalletClick = () => emit('wallet-click')

    return { handleWalletClick }
  },
  components: {
    UiFooterTokenWidgetPrice,
    UiFooterTokenWidgetInfoRow,
    UiFooterTokenWidgetAddMenamaskButton,
    UiButton,
    UiIconWalletMetamask,
  }
})
</script>

<style>
.ui-token-widget {
  @apply uikit-bg-gray-300 uikit-text-white uikit-rounded-8 uikit-p-20 uikit-flex uikit-justify-between uikit-shrink-0 uikit-text-ui-page-label;
}

.ui-token-widget_token {
  @apply uikit-mr-16 uikit-flex uikit-flex-col uikit-justify-between;
}

.ui-token-widget_info {
  @apply uikit-text-ui-page-label uikit-space-y-4;
  max-width: 400px;
  flex-grow: 1;
}
</style>